function loadIntelligentDialogMain()
{
	try {
		init();
		
		document.getElementById("intelligentDialog").innerHTML = System.Gadget.document.getElementById("isd").innerHTML;
		document.getElementById("intelligentDialog").style.backgroundRepeat = "no-repeat";
		document.getElementById("intelligentDialog").style.backgroundPosition = "bottom right";
		document.getElementById("intelligentDialog").style.backgroundImage = "url(http://www.digitaldiagnosis.de/dd_bookmarks/v" + System.Gadget.version + "/intelligent_dialogs/" + document.getElementById("domain").value + ".png)";
		document.body.style.height = document.getElementById("dialogHeight").value + "px";
		document.getElementById("intelligentDialog").style.height = (document.getElementById("dialogHeight").value - 40) + "px";
		objs = getIDialogObjects();
		if (searchHistory[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value].length == objs.length)
		{
			for (i = 0; i < objs.length; i++){
				if (objs[i].type == "checkbox") {
					objs[i].checked = searchHistory[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value][i] == "true";
				} else {
					objs[i].value = searchHistory[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value][i];
				}
			}
		}
		
		refreshFocus();
	} catch (exception) {
		log("loadIntelligentMain: "+exception.name+", "+exception.message);
	}
}

function getIDialogObjects()
{
	iDialogObjects = new Array();
	for (var j = 0; j < document.getElementsByTagName("input").length; j++){
		if (document.getElementsByTagName("input")[j].name == "iDialog")
		{
			iDialogObjects[iDialogObjects.length] = document.getElementsByTagName("input")[j];
		}
	}
	
	return iDialogObjects;
}

function callIntelligentDialogBookmark()
{
	try {
		searchValues = new Array();
		objs = getIDialogObjects();
		for (i = 0; i < objs.length; i++){
			searchValues[searchValues.length] = getHTMLElemValue(objs[i]);
		}
		searchHistory[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value] = searchValues;
		saveBookmarks();
		
		url = System.Gadget.document.getElementById("bookmarkUrl").value;
		for (i = 0; i < objs.length; i++)
		{
			if (i==0){url+="?";}else{url+="&";}
			url += objs[i].id + "=" + escape(getHTMLElemValue(objs[i]));
		}
		
		callBookmark(url, false, true);
	} catch (exception) {
		log("callIntelligentDialogBookmark: "+exception.name+", "+exception.message);
	}
}

function getHTMLElemValue()
{
	if (objs[i].type == "checkbox") {
		return objs[i].checked;
	} else {
		return objs[i].value;
	}
}

function deactivateIntelligentDialog(active)
{
	try {
		if (active == false)
		{
			intelligentDialogs[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value] = 1;
		}
		else
		{
			intelligentDialogs[selectedBookmarkSet][System.Gadget.document.getElementById("lastCalledBookmarkId").value] = 0;
		}
		saveBookmarks();
	} catch (exception) {
		log("deactivateIntelligentDialog: "+exception.name+", "+exception.message);
	}
}

function refreshFocus()
{
	try {
		objs = getIDialogObjects();
		if (objs.length > 0)
		{
			for (i = 0; i < objs.length; i++)
			{
				if (checkVisibility(objs[i]))
				{
					objs[i].select();
					objs[i].focus();
					break;
				}
			}
		}
	} catch (exception) {
		log("refreshFocus: "+exception.name+", "+exception.message);
	}
}

function checkVisibility(obj)
{
	while (obj)
	{
		if (obj.style && obj.style.display == "none")
		{
			return false;
		}
		obj = obj.parentNode;
	}
	return true;
}

function log(message){addError(message);}