function loadTutorialsMain() {
	try {
		init();
		
		document.getElementById("navi").style.display = "none";
		document.getElementById("loaderbar").style.display = "block";
		document.getElementById("tutorials").style.display = "none";
		document.getElementById("showTutorialIconButton").style.display = "block";
		if (serverOnline()) {
			XMLHttp2Tutorials = new ActiveXObject("Microsoft.XMLHTTP");
			XMLHttp2Tutorials.open("GET", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks/tutorials.php?version=" + System.Gadget.version), true);
			XMLHttp2Tutorials.onreadystatechange=function() {
				if (XMLHttp2Tutorials.readyState == 4)
				{
					if (XMLHttp2Tutorials.ResponseText != "") {
						document.getElementById("tutorials").innerHTML = XMLHttp2Tutorials.ResponseText;
						
					} else {
						document.getElementById("tutorials").innerHTML = l.get("tutorialsNoTutorialsAvailable");
					}
					document.getElementById("tutorials").style.display = "block";
					document.getElementById("loaderbar").style.display = "none";
					document.getElementById("tutorialsIntroduction").style.display = "block";
				}
			}
			XMLHttp2Tutorials.send(null);
		} else {
			document.getElementById("tutorials").innerHTML = l.get("tutorialsNotAvailable");
		}
	} catch (exception) {
		log("log: "+exception.name+", "+exception.message);
	}
}

function showTutorial(tutorialId) {
	try {
		if (serverOnline()) {
			XMLHttp2Tutorials = new ActiveXObject("Microsoft.XMLHTTP");
			XMLHttp2Tutorials.open("GET", getCompletedUrl("http://www.digitaldiagnosis.de/dd_bookmarks/tutorials.php?version=" + System.Gadget.version + "&showTutorial=" + tutorialId), true);
			XMLHttp2Tutorials.onreadystatechange=function() {
				if (XMLHttp2Tutorials.readyState == 4)
				{
					if (XMLHttp2Tutorials.ResponseText != "") {
						document.getElementById("tutorials").innerHTML = XMLHttp2Tutorials.ResponseText;
						document.getElementById("navi").style.display = "block";
						document.getElementById("loaderbar").style.display = "none";
						document.getElementById("tutorials").style.display = "block";
						document.getElementById("tutorialsIntroduction").style.display = "none";
						document.getElementById("showTutorialIconButton").style.display = "none";
					}
				}
			}
			XMLHttp2Tutorials.send(null);
		} else {
			document.getElementById("tutorials").innerHTML = l.get("tutorialsNotAvailable");
		}
	} catch (exception) {
		log("showTutorial: " + exception.name + ", " + exception.message);
	}
}

function log(message, append){addError(message);}